
function Renderable() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
}


function Tile() {
    this.src = null;
    this.srcX = 0;
    this.srcY = 0;
}

Tile.prototype = new Renderable();

function Sprite() {
    this.src = null;
    this.srcFrameX = 0; //should be measured in frames, not px
    this.srcFrameY = 0; //ditto
    this.srcFrameStrideX = 0; //width between frames (in case of margin)
    this.srcFrameStrideY = 0; //height between frames
    this.curAnimation = 0;
    this.animations = {};
}

Sprite.prototype = new Renderable();

Sprite.prototype.addAnimation = function(name, frames)
{
    var newAnim = new Animation();
    newAnim.frames = frames;
    newAnim.curFrame = 0;
    newAnim.totalFrames = frames.length;
    this.animations[name] = newAnim;
}

Sprite.prototype.stepAnimationFrame = function(animName)
{
    this.curAnimation = animName;
    var curAnim = this.animations[animName];
    curAnim.curFrame = (curAnim.curFrame + 1) % curAnim.totalFrames;
}

function Layer() {
    this.x = 0;
    this.y = 0;
}

function TileLayer() {
    this.tiles = [];   
}

TileLayer.prototype = new Layer();

function SpriteLayer() {
    this.sprites = [];
}

SpriteLayer.prototype = new Layer();

function Scene() {
    this.layers = [];
}

function Frame(fx, fy, dx, dy){
   this.frameX = fx;
   this.frameY = fy;
   this.modifyDestX = dx;
   this.modifyDestY = dy;
}

function Animation() {
   this.frames = [];
   this.curFrame = 0;
   this.totalFrames = 0;
}


