var express = require('express')
    ,app = express.createServer()
    ,io = require('socket.io').listen(app)
    //,ejs = require('ejs')
    ,stat = __dirname + '/Static';
    
app.configure(function() {
    app.set('view engine', 'ejs');
    app.set('view options', {layout: false});
    app.set('views', __dirname + '/Views');
    app.set('partials', __dirname + '/Views/Partials');
    
    app.use(express.cookieParser());
    //TODO: change this to a configuration value later
    app.use(express.session({ secret: 'change to config value later' }));
    app.use(express.bodyParser());
    
    app.use(express.compiler({ src: stat, enable: ['less'] }));
    app.use(app.router);
    app.use(express.static(stat)); //static content like images
    
    //TODO: use production/development configurations later
    app.use(express.errorHandler({ dumpExceptions: true, showStack: true }));
});

app.get('/', function(req, res) {
    res.render('index', {
        request: req,
        response: res,
        appdir: __dirname
    }); 
});

var numClients = 0;
var socketNum = 0; //always incremements, temporary server-side UID test

io.sockets.on('connection', function(socket) {
    io.sockets.emit('login', { numClients: ++numClients });
    
    var mySocketNum = ++socketNum;
    
    socket.on('say', function(data) {
        console.log(data);
        
        data.name = mySocketNum;
        io.sockets.emit('said', data);
    });
    
    socket.on('move', function(data) {
       io.sockets.emit('moved', data);  
    });
    
    socket.on('disconnect', function(socket) {
        io.sockets.emit('logout', { numClients: --numClients });
    });
});

//TODO: change this to config value
app.listen(process.env.C9_PORT);
